Index: branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 492)
+++ branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 494)
@@ -8503,110 +8378,52 @@
   p_vci_ixr.clen    = 0;
   p_vci_ixr.cfixed  = false;
-  p_vci_ixr.plen    = 64;
-
-  if(r_ixr_cmd_fsm.read() == IXR_CMD_READ)
+
+  if ( (r_ixr_cmd_fsm.read() == IXR_CMD_READ_SEND) or
+       (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_SEND) or
+       (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_SEND) or
+       (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_SEND) or
+       (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_SEND) )
   {
-    p_vci_ixr.cmd       = vci_param_ext::CMD_READ;
-    p_vci_ixr.cmdval    = true;
-    p_vci_ixr.address   = (addr_t)(r_read_to_ixr_cmd_nline.read() * m_words * 4);
-    p_vci_ixr.wdata     = 0;
-    p_vci_ixr.trdid     = r_read_to_ixr_cmd_trdid.read();
-    p_vci_ixr.eop       = true;
+      p_vci_ixr.cmdval  = true;
+
+      if ( r_ixr_cmd_get.read() )  // GET
+      {
+          p_vci_ixr.cmd     = vci_param_ext::CMD_READ;
+          p_vci_ixr.wdata   = 0;
+          p_vci_ixr.eop     = true;
+      }
+      else                         // PUT
+      {
+          size_t word       = r_ixr_cmd_word.read();
+          p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
+          p_vci_ixr.wdata   = ((wide_data_t)(r_ixr_cmd_wdata[word].read()))  |
+                              ((wide_data_t)(r_ixr_cmd_wdata[word+1].read()) << 32);
+          p_vci_ixr.eop     = (word == (m_words-2));
+      }
   }
-  else if(r_ixr_cmd_fsm.read() == IXR_CMD_CAS)
-  {
-    if(r_cas_to_ixr_cmd_write.read())
-    {
-      size_t word       = r_ixr_cmd_cpt.read();
-      p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
-      p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)( (r_cas_to_ixr_cmd_nline.read() * m_words + word) * 4 );
-      p_vci_ixr.wdata   = ((wide_data_t)(r_cas_to_ixr_cmd_data[word].read()))  |
-                          ((wide_data_t)(r_cas_to_ixr_cmd_data[word+1].read()) << 32);
-      p_vci_ixr.trdid   = r_cas_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words-2));
-    }
-    else
-    {
-      p_vci_ixr.cmd     = vci_param_ext::CMD_READ;
-      p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)(r_cas_to_ixr_cmd_nline.read() *m_words*4);
-      p_vci_ixr.wdata   = 0;
-      p_vci_ixr.trdid   = r_cas_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = true;
-    }
-  }
-  else if(r_ixr_cmd_fsm.read() == IXR_CMD_WRITE)
-  {
-    if(r_write_to_ixr_cmd_write.read())
-    {
-      p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
-      p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)( (r_write_to_ixr_cmd_nline.read() * m_words +
-                                     r_ixr_cmd_cpt.read()) * 4 );
-      p_vci_ixr.wdata   = ((wide_data_t)(r_write_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) |
-                          ((wide_data_t)(r_write_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
-      p_vci_ixr.trdid   = r_write_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words-2));
-    }
-    else
-    {
-      p_vci_ixr.cmd     = vci_param_ext::CMD_READ;
-      p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)(r_write_to_ixr_cmd_nline.read() *m_words*4);
-      p_vci_ixr.wdata   = 0;
-      p_vci_ixr.trdid   = r_write_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = true;
-    }
-  }
-  else if(r_ixr_cmd_fsm.read() == IXR_CMD_XRAM)
-  {
-    p_vci_ixr.cmd       = vci_param_ext::CMD_WRITE;
-    p_vci_ixr.cmdval    = true;
-    p_vci_ixr.address   = (addr_t)( (r_xram_rsp_to_ixr_cmd_nline.read() * m_words +
-                                   r_ixr_cmd_cpt.read()) * 4 );
-    p_vci_ixr.wdata     = ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) |
-                          ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
-    p_vci_ixr.trdid     = r_xram_rsp_to_ixr_cmd_trdid.read();
-    p_vci_ixr.eop       = (r_ixr_cmd_cpt == (m_words-2));
-  } 
   /*ODCCP*/
-  else if (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_DATA)
+  else if (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_DATA_SEND)
   {
     p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
     p_vci_ixr.cmdval  = true;
+#if ODCCP_NON_INCLUSIVE
     p_vci_ixr.address = (addr_t)((r_cleanup_to_ixr_cmd_nline.read() * m_words + 
-                                    r_ixr_cmd_cpt.read()) * 4);
-#if ODCCP_NON_INCLUSIVE
-    p_vci_ixr.wdata   = ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) | 
-          ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_cpt.read() + 1].read()) << 32));
+                                    r_ixr_cmd_word.read()) * 4);
+    p_vci_ixr.wdata   = ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_word.read()].read()) | 
+          ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_word.read() + 1].read()) << 32));
 #else 
-    p_vci_ixr.wdata   = ((wide_data_t)(r_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) | 
-          ((wide_data_t)(r_ixr_cmd_data[r_ixr_cmd_cpt.read() + 1].read()) << 32));
+    /*p_vci_ixr.address = (addr_t)((r_cleanup_to_ixr_cmd_nline.read() * m_words + 
+                                    r_ixr_cmd_word.read()) * 4);*/
+    p_vci_ixr.address = (addr_t)r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2);
+    p_vci_ixr.wdata   = ((wide_data_t)(r_ixr_cmd_wdata[r_ixr_cmd_word.read()].read()) | 
+          ((wide_data_t)(r_ixr_cmd_wdata[r_ixr_cmd_word.read() + 1].read()) << 32));
 #endif
     
-    /*
-    if(r_cleanup_to_ixr_cmd_l1_dirty_ncc.read()) // if cleanup data contains data, we use cleanup_data buffer (cleanup dirty)
-    {
-      p_vci_ixr.wdata   = ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) | 
-          ((wide_data_t)(r_cleanup_to_ixr_cmd_data[r_ixr_cmd_cpt.read() + 1].read()) << 32));
-    }
-    else // if cleanup data doesnt contain data, we use xram_rsp_data buffer (cleanup not dirty)
-    {
-      p_vci_ixr.wdata   = ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) | 
-          ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read() + 1].read()) << 32));
-    }
-    */
-    p_vci_ixr.trdid   = r_cleanup_to_ixr_cmd_trdid.read();
-    p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words - 2));
+    p_vci_ixr.trdid   = r_cleanup_to_ixr_cmd_index.read();
+    p_vci_ixr.eop     = (r_ixr_cmd_word == (m_words - 2));
   }
   else
   {
-    p_vci_ixr.cmdval    = false;
-    p_vci_ixr.cmd       = vci_param_ext::CMD_READ;
-    p_vci_ixr.address   = 0;
-    p_vci_ixr.wdata     = 0;
-    p_vci_ixr.trdid     = 0;
-    p_vci_ixr.eop       = false;
+      p_vci_ixr.cmdval = false;
   }
 
@@ -8615,12 +8432,17 @@
   ////////////////////////////////////////////////////
 
-  if(((r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) and
-      (r_ixr_rsp_fsm.read()   == IXR_RSP_TRT_READ)) or
-      (r_ixr_rsp_fsm.read()   == IXR_RSP_ACK))
-
-    p_vci_ixr.rspack = true;
-
-  else
-    p_vci_ixr.rspack = false;
+  if( (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ) or
+      (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) )
+  { 
+      p_vci_ixr.rspack = (r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP);
+  }
+  else if (r_ixr_rsp_fsm.read() == IXR_RSP_ACK)
+  {
+      p_vci_ixr.rspack = true;
+  }
+  else // r_ixr_rsp_fsm == IXR_RSP_IDLE
+  {
+      p_vci_ixr.rspack = false;
+  }
 
   ////////////////////////////////////////////////////
@@ -8688,9 +8510,8 @@
       break;
     }
-
     case TGT_RSP_TGT_CMD:
     {
       p_vci_tgt.rspval  = true;
-      p_vci_tgt.rdata   = 0;
+      p_vci_tgt.rdata   = r_tgt_cmd_to_tgt_rsp_rdata.read();
       p_vci_tgt.rsrcid  = r_tgt_cmd_to_tgt_rsp_srcid.read();
       p_vci_tgt.rtrdid  = r_tgt_cmd_to_tgt_rsp_trdid.read();
@@ -8701,5 +8522,4 @@
       break;
     }
-
     case TGT_RSP_READ:
     {
@@ -9196,69 +9016,49 @@
   ////////////////////////////////////////////////////////////////////
 
-  switch(r_cleanup_fsm.read())
+  if ( r_cleanup_fsm.read() == CLEANUP_SEND_CLACK )
   {
-    case CLEANUP_IDLE:
-    case CLEANUP_GET_NLINE:
-    case CLEANUP_DIR_REQ:
-    case CLEANUP_DIR_LOCK:
-    case CLEANUP_DIR_WRITE:
-    case CLEANUP_HEAP_REQ:
-    case CLEANUP_HEAP_LOCK:
-    case CLEANUP_HEAP_SEARCH:
-    case CLEANUP_HEAP_CLEAN:
-    case CLEANUP_HEAP_FREE:
-    case CLEANUP_IVT_LOCK:
-    case CLEANUP_IVT_DECREMENT:
-    case CLEANUP_IVT_CLEAR:
-    case CLEANUP_WRITE_RSP:
-    case CLEANUP_CONFIG_ACK:
+      uint8_t cleanup_ack_type;
+      if(r_cleanup_inst.read())
+      {
+          cleanup_ack_type = DspinDhccpParam::TYPE_CLACK_INST;
+      }
+      else
+      {
+          cleanup_ack_type = DspinDhccpParam::TYPE_CLACK_DATA;
+      }
+
+      uint64_t flit = 0;
+      uint64_t dest = r_cleanup_srcid.read() <<
+          (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
+
+      DspinDhccpParam::dspin_set(
+            flit,
+            dest,
+            DspinDhccpParam::CLACK_DEST);
+
+      DspinDhccpParam::dspin_set(
+            flit,
+            r_cleanup_nline.read() & 0xFFFF,
+            DspinDhccpParam::CLACK_SET);
+
+      DspinDhccpParam::dspin_set(
+            flit,
+            r_cleanup_way_index.read(),
+            DspinDhccpParam::CLACK_WAY);
+
+      DspinDhccpParam::dspin_set(
+            flit,
+            cleanup_ack_type,
+            DspinDhccpParam::CLACK_TYPE);
+
+      p_dspin_clack.eop   = true;
+      p_dspin_clack.write = true;
+      p_dspin_clack.data  = flit;
+  }
+  else
+  {
       p_dspin_clack.write = false;
       p_dspin_clack.eop   = false;
       p_dspin_clack.data  = 0;
-
-      break;
-
-    case CLEANUP_SEND_CLACK: 
-      {
-        uint8_t cleanup_ack_type;
-        if(r_cleanup_inst.read())
-        {
-          cleanup_ack_type = DspinDhccpParam::TYPE_CLACK_INST;
-        }
-        else
-        {
-          cleanup_ack_type = DspinDhccpParam::TYPE_CLACK_DATA;
-        }
-
-        uint64_t flit = 0;
-        uint64_t dest =
-          r_cleanup_srcid.read() <<
-          (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            dest,
-            DspinDhccpParam::CLACK_DEST);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            r_cleanup_nline.read() & 0xFFFF,
-            DspinDhccpParam::CLACK_SET);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            r_cleanup_way_index.read(),
-            DspinDhccpParam::CLACK_WAY);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            cleanup_ack_type,
-            DspinDhccpParam::CLACK_TYPE);
-
-        p_dspin_clack.eop   = true;
-        p_dspin_clack.write = true;
-        p_dspin_clack.data  = flit;
-      }
-      break;
   }
 
